// HanoiMotion.cpp - nmC̓̕\ƓiB
// Copyright(C) 2007 KONNO Akihisa <konno@researchers.jp>
// All rights reserved.

#include "stdafx.h"
#include <iostream>
#include <cstdlib>

#define MAXHEIGHT 11

int state[3][MAXHEIGHT + 1];

int topidx[3];

const int maxdiscsize = MAXHEIGHT * 2 + 1;
const int headheight = 10;
const int leftmargin = 2;
const int colsep = 2;

char ground1[] = " ******************************************************************************";
char ground2[] = "             1                        2                        3             ";

char column = '|';
char disc = '=';

static void hanoi_comment(char *str)
{
	for (int i = 0; i < headheight / 2; ++i)
		std::cout << std::endl;
	std::cout << str << std::endl;
	for (int i = 0; i < headheight / 2; ++i)
		std::cout << std::endl;
}

static void hanoi_view()
{
	for (int i = MAXHEIGHT; i >= 0; --i) {
		// left margin
		for (int j = 0; j < leftmargin; ++j)
			std::cout << ' ';

		// nmC̓A1{
		if (state[0][i] == 0) {
			// column
			for (int j = 0; j < (maxdiscsize - 1) / 2; ++j)
				std::cout << ' ';
			std::cout << column;
			for (int j = 0; j < (maxdiscsize - 1) / 2; ++j)
				std::cout << ' ';
		} else {
			// disc
			int radius = state[0][i];
			for (int j = 0; j < (maxdiscsize - 1) / 2 - radius; ++j)
				std::cout << ' ';
			for (int j = 0; j < radius * 2 + 1; ++j)
				std::cout << disc;
			for (int j = 0; j < (maxdiscsize - 1) / 2 - radius; ++j)
				std::cout << ' ';
		}

		// colsep
		for (int j = 0; j < leftmargin; ++j)
			std::cout << ' ';

		// nmC̓A2{
		if (state[1][i] == 0) {
			// column
			for (int j = 0; j < (maxdiscsize - 1) / 2; ++j)
				std::cout << ' ';
			std::cout << column;
			for (int j = 0; j < (maxdiscsize - 1) / 2; ++j)
				std::cout << ' ';
		} else {
			// disc
			int radius = state[1][i];
			for (int j = 0; j < (maxdiscsize - 1) / 2 - radius; ++j)
				std::cout << ' ';
			for (int j = 0; j < radius * 2 + 1; ++j)
				std::cout << disc;
			for (int j = 0; j < (maxdiscsize - 1) / 2 - radius; ++j)
				std::cout << ' ';
		}

		// colsep
		for (int j = 0; j < leftmargin; ++j)
			std::cout << ' ';

		// nmC̓A3{
		if (state[2][i] == 0) {
			// column
			for (int j = 0; j < (maxdiscsize - 1) / 2; ++j)
				std::cout << ' ';
			std::cout << column;
			for (int j = 0; j < (maxdiscsize - 1) / 2; ++j)
				std::cout << ' ';
		} else {
			// disc
			int radius = state[2][i];
			for (int j = 0; j < (maxdiscsize - 1) / 2 - radius; ++j)
				std::cout << ' ';
			for (int j = 0; j < radius * 2 + 1; ++j)
				std::cout << disc;
			for (int j = 0; j < (maxdiscsize - 1) / 2 - radius; ++j)
				std::cout << ' ';
		}

		std::cout << std::endl;
	}
	std::cout << ground1 << std::endl << ground2 << std::endl << std::endl;
}

void hanoi_init(int height)
{
	if (height > MAXHEIGHT) {
		std::cerr << "w肳ꂽ" << height << "͍ő̍" << MAXHEIGHT
			<< "荂̂ŁA邱Ƃł܂B" << std::endl;
		exit(EXIT_FAILURE);
	}
	for (int i = 0; i <= MAXHEIGHT; ++i) {
		if (i < height)
			state[0][i] = height - i;
		else
			state[0][i] = 0;
		state[1][i] = state[2][i] = 0;
	}
	topidx[0] = height - 1;
	topidx[1] = topidx[2] = -1;

	hanoi_comment("܂B");
	hanoi_view();
}

void hanoi_move(int col_a, int col_b)
{
	// col_acol_bɃfBXNڂB

	char *msg = "fBXNړ܂B";

	if (1 <= col_a && col_a <= 3 && 1 <= col_b && col_b <= 3) {
		int topidx_a = topidx[col_a - 1], topidx_b = topidx[col_b - 1];
		int topsize_a, topsize_b;

		if (topidx_a < 0) {
			hanoi_comment("ɃfBXN܂B");
			hanoi_view();
			return;
		} else
			topsize_a = state[col_a - 1][topidx_a];
		if (topidx_b < 0)
			topsize_b = 1000;	// uĂ悢B
		else
			topsize_b = state[col_b - 1][topidx_b];

		if (topsize_a >= topsize_b)
			msg = "傫fBXN̏ɏfBXNڂ邱Ƃ͂ł܂B";
		else {
			state[col_b - 1][topidx_b + 1] = topsize_a;
			state[col_a - 1][topidx_a] = 0;
			--topidx[col_a - 1];
			++topidx[col_b - 1];
		}
	} else {
		msg = "̔ԍłB";
	}

	hanoi_comment(msg);
	hanoi_view();
}